<template>
    <div class="card">
        <div class="card-body">
            <div class="calendar">
                <FullCalendar
                        class="app-calendar"
                        defaultView="timeGridWeek"
                        ref="fullCalendar"
                        :plugins="calendarPlugins"
                        :selectable="true"
                        locale="fr"
                        :locales="allLocales"
                        :header="{
                    left: 'prev,next today',
                    center: 'title',
                    right: 'timeGridWeek,timeGridDay'
                 }"
                        :events="events"
                        @eventClick="showEvent"
                        @select="handleDateClick"
                />

                <!-- Modal components REUNION -->
                <CModal
                        :show.sync="modal"
                        :no-close-on-backdrop="true"
                        :centered="true"
                        title="Modal title 1"
                        size="xl"
                        color="dark"
                >
                    <template #body-wrapper>
                        <div class="container-fluid">
                            <div class="row">
                                <div class="col-sm-6">

                                    <div class="form-group row" style="margin-top: 15px">
                                        <label class="col-md-2 col-form-label"
                                               style="max-width: 20%">Date</label>
                                        <div class="col-md-9" style="margin-top: 5px; margin-left: 8px;">
                                            <b>{{startDate}}</b> au <b>{{endDate}}</b> <br>
                                        </div>
                                    </div>

                                    <div class="form-group row" style="margin-top: 15px">
                                        <label class="col-md-2 col-form-label" for="libelle_salle"
                                               style="min-width: 18%">Titre</label>
                                        <div class="col-md-9">
                                            <input class="form-control" id="libelle_salle" type="text"
                                                   name="libelle_salle" placeholder="Saisissez le titre"
                                                   v-model="reunion.titre">
                                        </div>
                                    </div>

                                    <div class="form-group row" style=" margin-top: 25px">
                                        <label class="col-md-2 col-form-label" style="min-width: 18%">Salle</label>
                                        <div class="col-md-9">
                                            <model-select :options="optionsSalle"
                                                          v-model="salleTemp"
                                                          placeholder="Sélectionner la salle">
                                            </model-select>
                                        </div>
                                    </div>

                                    <div class="form-group row" style=" margin-top: 30px">
                                        <label class="col-md-2 col-form-label"
                                               style="max-width: 20%">Participants</label>
                                        <div class="col-md-9">
                                            <multi-select :options="optionsUser"
                                                          :selected-options="users"
                                                          placeholder="sélectionner les participants"
                                                          :isError="selectUsersCheck"
                                                          @select="onSelect">
                                            </multi-select>
                                        </div>
                                    </div>

                                    <div class="form-group row"  style=" margin-top: 20px">
                                        <label class="col-md-2 col-form-label"
                                               style="max-width: 20%">Description</label>
                                        <div class="col-md-8">
                                                <textarea id="description" name="description"
                                                          rows="3" cols="53" style="border-color: darkgrey;"
                                                          v-model="reunion.description">
                                                </textarea>
                                        </div>
                                    </div>
                                </div>

                                <div class="col-sm-6" style="margin-top: 100px">
                                    <p>Capacité: <b> {{salleTemp.capacite}} </b><br></p>
                                    <p>Emplacement : <b>{{salleTemp.emplacement}} </b><br></p>
                                    <p>Equipement : <b> {{salleTemp.equipementsLibelle}} </b><br></p>
                                    <p v-if="salleTemp.pmr === true">Personne à mobilité réduite : <b> Oui</b></p>
                                    <p v-else-if="salleTemp.pmr === false">Personne à mobilité réduite : <b> Non</b></p>
                                    <p v-else>Personne à mobilité réduite : <b> </b></p>
                                </div>
                            </div>
                        </div>

                    </template>

                    <template #header>
                        <h6 class="modal-title">Enregistrer une réunion</h6>
                        <CButtonClose @click="modal = false" class="text-white"/>
                    </template>
                    <template #footer>
                        <CButton @click="modal = false" color="danger">Annuler</CButton>
                        <CButton @click="createMeeting()" color="success">Enregistrer</CButton>
                    </template>
                </CModal>

                <!-- Modal components EVENT -->
                <CModal
                        :show.sync="modalEvent"
                        :no-close-on-backdrop="true"
                        :centered="true"
                        title="Modal title 2"
                        size="lg"
                        color="info"
                >
                    <template #body-wrapper>

                    </template>

                    <template #header>
                        <h6 class="modal-title">{{eventModal.title}}</h6>
                        <CButtonClose @click="modalEvent = false" class="text-white"/>
                    </template>
                    <div class="container-fluid">
                        <div class="row">
                            <div style="margin-top:5px">
                                Date : <b>{{eventModal.start}}</b> au <b>{{eventModal.end}}</b>
                            </div>
                        </div>
                        <div class="row">
                            <div style="margin-top:5px">
                                Participants : <b>{{eventModal.usersStr}}</b>
                            </div>
                        </div>
                        <div class="row">
                            <div style="margin-top:5px">
                                Salle : <b>{{eventModal.salle}}</b>
                            </div>
                        </div>
                        <div class="row">
                            <div style="margin-top:5px">
                                Description : <b>{{eventModal.description}}</b>
                            </div>
                        </div>
                    </div>
                    <template #footer>
                        <CLink href="#" class="card-header-action btn-close" @click="deleteEvent()">
                            <CIcon color="red" name="cil-x-circle"/>
                        </CLink>
                    </template>
                </CModal>


            </div>
        </div>
    </div>
</template>

<script>
    import FullCalendar from '@fullcalendar/vue'
    import dayGridPlugin from '@fullcalendar/daygrid'
    import timeGridPlugin from '@fullcalendar/timegrid'
    import interactionPlugin from '@fullcalendar/interaction'
    import moment from 'moment'
    import {ModelSelect, MultiSelect} from 'vue-search-select'
    import allLocales from "@fullcalendar/core/locales-all";
    import swal from "sweetalert";
    import VueJwtDecode from "vue-jwt-decode";

    export default {
        name: 'Dashboard',
        components: {
            FullCalendar,
            ModelSelect,
            MultiSelect
        },
        data() {
            return {
                calendarPlugins: [dayGridPlugin, interactionPlugin, timeGridPlugin],
                allLocales,
                modal: false,
                modalEvent: false,
                selectUsersCheck: false,
                startDate: null,
                endDate: null,
                optionsSalle: [],
                salleTemp: {
                    value: '',
                    text: '',
                    libelle: '',
                    capacite: '',
                    emplacement: '',
                    equipement: [],
                    pmr: '',
                    reservations: '',
                    equipementsLibelle: ""
                },
                optionsUser: [],
                users: [],
                lastSelectUser: {},
                reunion: {
                    titre: '',
                    date_debut: '',
                    date_fin: '',
                    salle: '',
                    users: [],
                    description: ''
                },
                events: [],
                event: {
                    title: null,
                    start: null,
                    end: null,
                    email: null,
                    description: null,
                    id_reunion: null,
                    salle: null,
                    usersEmail: []
                },
                eventModal: {
                    title: null,
                    start: null,
                    end: null,
                    email: null,
                    description: null,
                    id_reunion: null,
                    salle: null,
                    users: [],
                    usersStr: null
                },

            }
        },
        methods: {
            handleDateClick(arg) {
                this.modal = true;
                this.reunion.date_debut = arg.start
                this.reunion.date_fin = arg.end
                this.startDate = moment(arg.start).format('llll')
                this.endDate = moment(arg.end).format('llll')
            },
            async getAllSalle() {
                await this.$http.get("/api/salles/getAllMeetingRoom")
                    .then(response => {
                        if (response.status === 200) {
                            var arraySalle = []
                            var i = 1
                            for (var salle of response.data) {
                                salle.text = salle.libelle
                                salle.value = i++
                                arraySalle.push(salle)
                                salle.equipementsLibelle = ""
                                var compteurEquipement = 1;
                                for (var equipement of salle.equipement) {
                                    salle.equipementsLibelle += equipement.libelle
                                    if (compteurEquipement < salle.equipement.length) {
                                        salle.equipementsLibelle += ", "
                                    }
                                    compteurEquipement++
                                }
                            }
                            this.optionsSalle = arraySalle

                        }
                    })
                    .catch(error => {
                        if (error.response && error.response.status === 500) {
                            swal("Erreur", error.response.data, "error");
                        } else {
                            swal("Erreur", "Une erreur est survenue", "error");
                        }
                    })
            },
            async getAllUsers() {
                let token = localStorage.getItem("jwt");
                let decoded = VueJwtDecode.decode(token);
                await this.$http.get("/api/users/getAllUsers")
                    .then(response => {
                        if (response.status === 200) {
                            var arrayUsers = []
                            var i = 1
                            for (var user of response.data) {
                                user.text = user.email
                                user.value = i++;
                                if(user.email !== decoded.email) {
                                    arrayUsers.push(user)
                                }
                            }
                            this.optionsUser = arrayUsers
                        }
                    })
                    .catch(error => {
                        if (error.response && error.response.status === 500) {
                            swal("Erreur", error.response.data, "error");
                        } else {
                            swal("Erreur", "Une erreur est survenue", "error");
                        }
                    })
            },
            onSelect(users, lastSelectUser) {
                this.users = users
                this.lastSelectUser = lastSelectUser
                this.reunion.users = this.users
                this.selectUsersCheck = this.users.length > this.optionsSalle[0].capacite;
            },
            async createMeeting() {
                this.reunion.salle = this.salleTemp
                let token = localStorage.getItem("jwt");
                let decoded = VueJwtDecode.decode(token);

                await this.$http.post("/api/reunions/createMeeting", this.reunion)
                    .then(response => {
                        if (response.status === 202 || response.status === 200) {
                            swal("Succès", response.data.msg, "success");
                            let event = {
                                title: this.reunion.titre,
                                start: this.reunion.date_debut,
                                end: this.reunion.date_fin,
                                description: this.reunion.description,
                                id_reunion: response.data.id_reunion,
                                salle: this.reunion.salle,
                                usersEmail: []
                            }
                            this.reunion.users.forEach(user => {
                                event.usersEmail.push(user.email)
                            })
                            event.usersEmail.push(decoded.email)
                            this.event.id_reunion = response.data.id_reunion
                            this.events.push(event)
                            this.createEvent()
                        }
                    })
                    .catch(error => {
                        if (error.response && error.response.status === 500) {
                            swal("Erreur", error.response.data, "error");
                        } else {
                            swal("Erreur", "Une erreur est survenue", "error");
                        }
                    })
                this.modal = false
            },
            async createEvent() {
                let token = localStorage.getItem("jwt");
                let decoded = VueJwtDecode.decode(token);
                this.event.email = decoded.email
                this.event.title = this.reunion.titre
                this.event.start = this.reunion.date_debut
                this.event.end = this.reunion.date_fin
                this.event.description = this.reunion.description
                this.event.salle = this.reunion.salle
                this.reunion.users.forEach(user => {
                    this.event.usersEmail.push(user.email)
                })
                this.event.usersEmail.push(decoded.email)
                await this.$http.post("/api/users/addEventByUser", this.event)
            },
            async deleteEvent() {
                let deleteEvent
                this.events.forEach((event, index) => {
                    if(event.id_reunion === this.eventModal.id_reunion) {
                        this.events.splice(index, 1)
                        deleteEvent = {
                            id_reunion: this.eventModal.id_reunion,
                            email: this.event.email
                        }
                    }
                })
                this.modalEvent = false
                await this.$http.post("/api/users/deleteEvent", deleteEvent)
                    .then(response => {
                        if (response.status === 202 || response.status === 200) {
                            swal("Succès", response.data.msg, "success");
                            this.deleteReservation()
                        }
                    })
                    .catch(error => {
                        if (error.response && error.response.status === 500) {
                            swal("Erreur", error.response.data, "error");
                        } else {
                            swal("Erreur", "Une erreur est survenue", "error");
                        }
                    })
            },
            async deleteReservation() {
                let deleteReservation = {
                    libelle: this.reunion.salle.libelle,
                    date_debut: this.event.start,
                    date_fin: this.event.end,
                }
                await this.$http.post("/api/salles/deleteReservation", deleteReservation)
            },
            getUserDetails() {
                let token = localStorage.getItem("jwt");
                let decoded = VueJwtDecode.decode(token);
                this.event.email = decoded.email
            },
            showEvent(arg) {
                console.log(arg)
                this.eventModal.title = arg.event.title
                this.eventModal.description = arg.event.extendedProps.description
                this.eventModal.start = moment(arg.event.start).format('llll')
                this.eventModal.end = moment(arg.event.end).format('llll')
                this.eventModal.id_reunion = arg.event.extendedProps.id_reunion
                this.eventModal.salle = arg.event.extendedProps.salle.libelle
                this.eventModal.users = arg.event.extendedProps.usersEmail
                this.eventModal.usersStr = this.eventModal.users.join(", ")
                this.modalEvent = true
            }
        },
        beforeMount() {
            this.getAllSalle()
            this.getAllUsers()
            this.getUserDetails()
            moment.locale("fr")
        },
        beforeCreate() {
            let token = localStorage.getItem("jwt");
            let decoded = VueJwtDecode.decode(token);
            this.$http.get("/api/users/getAllEventsByUser?email=" + decoded.email)
                .then(response => {
                    if (response.status === 200) {
                        response.data.forEach(event => {
                            delete event._id
                            this.events.push(event)
                        })
                    }
                })
                .catch(error => {
                    if (error.response && error.response.status === 500) {
                        swal("Erreur", error.response.data, "error");
                    } else {
                        swal("Erreur", "Une erreur est survenue", "error");
                    }
                })
        }

    }
</script>


<style lang='scss'>
    @import '~@fullcalendar/core/main.css';
    @import '~@fullcalendar/daygrid/main.css';
    @import '~@fullcalendar/timegrid/main.css';

    .calendar {
        font-family: Arial, Helvetica Neue, Helvetica, sans-serif;
        font-size: 14px
    }

    .app-calendar {
        margin: 0 auto

    }

    .fixed {
        width: 50px
    }

    .flex-item {
        flex-grow: 0.8
    }

    input[type=text], textarea {
        -webkit-transition: all 0.30s ease-in-out;
        -moz-transition: all 0.30s ease-in-out;
        -ms-transition: all 0.30s ease-in-out;
        -o-transition: all 0.30s ease-in-out;
        outline: none;
        padding: 3px 0px 3px 3px;
        margin: 5px 1px 3px 0px;
        border: 1px solid #DDDDDD;
    }

    input[type=text]:focus, textarea:focus {
        box-shadow: 0 0 5px rgba(81, 203, 238, 1);
        padding: 3px 0px 3px 3px;
        margin: 5px 1px 3px 0px;
        border: 1px solid rgba(81, 203, 238, 1);
    }

</style>
